package top.ninwoo.test;


import com.pitong.business.item.DataPackage;
import com.pitong.business.item.Picture;
import org.springframework.beans.factory.annotation.Value;
import org.springframework.boot.ApplicationArguments;
import org.springframework.boot.ApplicationRunner;
import org.springframework.boot.Banner;
import org.springframework.boot.WebApplicationType;
import org.springframework.boot.autoconfigure.SpringBootApplication;
import org.springframework.boot.builder.SpringApplicationBuilder;
import top.ninwoo.test.doMap.DoMap;
import top.ninwoo.test.doMap.path;

import java.io.*;
import java.net.ServerSocket;
import java.net.Socket;
import java.util.Arrays;
import java.util.List;
import java.util.Random;

@SpringBootApplication
@path
public class BisheTestMain implements ApplicationRunner {

    @Value("${eta}")
    private double ETA;

    @Value("${targetIp}")
    private String targetIp;

    public static void main(String[] args) {
        new SpringApplicationBuilder(BisheTestMain.class)
                .web(WebApplicationType.NONE) // .REACTIVE, .SERVLET
                .bannerMode(Banner.Mode.OFF)
                .run(args);
    }

    @Override
    public void run(ApplicationArguments args) throws Exception {
        //解析注解
        Class<BisheTestMain> bisheTestMainClass = BisheTestMain.class;
        path annotation = bisheTestMainClass.getAnnotation(path.class);
        String rmCmd = annotation.rmCmd();
        String saveCmd1 = annotation.saveCmd1();
        String saveCmd2 = annotation.saveCmd2();
        String saveCmd3 = annotation.saveCmd3();
        String saveCmd4 = annotation.saveCmd4();
        String saveCmd5 = annotation.saveCmd5();
        String savePath = annotation.savePath();


        System.out.println("========================================");
        System.out.println("exec start timestamp: " + System.currentTimeMillis());
        System.out.println();


//        DoMap doMap = new DoMap();

        List<Integer> sequence = Arrays.asList(1, 3, 7, 8, 12, 17, 20);
        System.out.println("optimal mapping scheme"+sequence);
        String loc = null;
        String file_path = "passport.jpg";

        int number = 1;
        double eta = ETA;
        Long currentime = System.currentTimeMillis();
        Long fun1time = Long.valueOf(0);
        List<Double> compCapacity = Arrays.asList(1.112341341313, 0.5196272109574349, 0.675827555541419, 0.7637869915859579, 0.7998320296858645,
                0.638652700648973, 0.6396760676518485, 0.5615337810185533, 0.6356797503522186, 0.8266103444996542, 0.6924037701405794,
                0.9371892689614395, 0.6949256728585527, 0.6212614126622614, 0.6318393608430264, 0.7494680794385384, 0.9983949989039682,
                0.5610722256465777, 0.6415780028672076, 0.9371892689);//取值范围0.2到1，首尾固定为1M/s
        DataPackage dataPackage = combine(number, sequence, loc, file_path, eta, currentime, fun1time, compCapacity);
        send(dataPackage, targetIp, 2020);

        for(int i = 0;i<sequence.size();i++){
            ServerSocket serverSocket = new ServerSocket(8900);
            //获取数据流
            Socket accept = serverSocket.accept();
            InputStream inputStream = accept.getInputStream();
            //读取数据流
            ObjectInputStream objectInputStream = new ObjectInputStream(new BufferedInputStream(inputStream));
            Object object = null;
            try {
                object = objectInputStream.readObject();
            } catch (ClassNotFoundException e) {
                e.printStackTrace();
            }
            List<String> strings = (List) object;
            //输出数据流
            for (String s:strings
            ) {
                System.out.println(s);
            }
            serverSocket.close();
            accept.close();
            System.out.println();
        }
        //生成保存目录
        File dirpath = new File(savePath);
        if (!dirpath.exists()){
            creatParent(dirpath);
            dirpath.mkdir();
        }

        try { // 起作用的代码其实就下面这一行, 参数是linux中要执行的代码
            Runtime.getRuntime().exec(rmCmd).waitFor();
            Runtime.getRuntime().exec(saveCmd1).waitFor();//jthudocker
            Runtime.getRuntime().exec(saveCmd2).waitFor();//jthudocker
            Runtime.getRuntime().exec(saveCmd3).waitFor();//jthudocker
            for(int i =1;i<sequence.size();i++){
                Runtime.getRuntime().exec("docker cp sate"+sequence.get(i)+saveCmd4+sequence.get(i)+".jpg").waitFor();
            }

        } catch (IOException e) {
            e.printStackTrace();
        } catch (InterruptedException e) {
            e.printStackTrace();
        }
        System.out.println(saveCmd5);
        System.out.println("========================================");

//        System.out.print("File size :");
//        System.out.println(dataPackage.getPicture().getData().length / 1000+"k");

    }

    private void creatParent(File dirpath) {
        File file = new File(dirpath.getParent());
        if (!file.exists()) {
            creatParent(file);
            file.mkdir();
        }
    }

    private static DataPackage combine(int number, List<Integer> sequence, String loc, String file_path, double eta, Long Currentime, Long fun1time, List<Double> compCapacity) {
        DataPackage dataPackage = new DataPackage();
        dataPackage.setNumber(number);
        dataPackage.setPicture(loadPicture(file_path));
        dataPackage.setSequence(sequence);
        dataPackage.setEta(eta);
        dataPackage.setCurrentime(Currentime);
        dataPackage.setFun1time(fun1time);
        dataPackage.setCompCapacity(compCapacity);
        return dataPackage;
    }

    private static Picture loadPicture(String pic_url) {
        try {
            File f = new File(pic_url);
            InputStream is = new FileInputStream(f);
            byte[] b = new byte[(int) f.length()];
            is.read(b);
            is.close();
            Picture picture = new Picture();
            picture.setData(b);
            return picture;
        } catch (Exception e) {
            e.printStackTrace();
        }
        return null;
    }

    private static void send(DataPackage dataPackage, String ip, int port) {
        Socket socket = null;
        try {
            socket = new Socket(ip, port);
            ObjectOutputStream objectOutputStream = new ObjectOutputStream(socket.getOutputStream());
            objectOutputStream.writeObject(dataPackage);
        } catch (IOException e) {
            e.printStackTrace();
        } finally {
            try {
                if (socket != null) {
                    socket.close();
                }
            } catch (IOException e) {
                e.printStackTrace();
            }
        }
    }

    /**
     * 得到0.5到1的随机数
     * @return
     */
    public static Double getRangeDate(){
        Double max=1.0;
        Double min=0.5;
        Random random = new Random();
        return random.nextDouble()%(max-min) + min;
    }

}
