package com.pitong.business;


import com.pitong.business.item.DataPackage;
import com.pitong.business.item.Picture;
import com.pitong.business.service.ServerService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.boot.*;
import org.springframework.boot.autoconfigure.SpringBootApplication;
import org.springframework.boot.builder.SpringApplicationBuilder;

import java.io.BufferedInputStream;
import java.io.IOException;
import java.io.InputStream;
import java.io.ObjectInputStream;
import java.lang.reflect.Method;
import java.net.ServerSocket;
import java.net.Socket;
import java.util.List;


@SpringBootApplication
public class Application implements ApplicationRunner {

    @Autowired
    private ServerService serverService;

    public static void main(String[] args) {
        new SpringApplicationBuilder(Application.class)
                .web(WebApplicationType.NONE) // .REACTIVE, .SERVLET
                .bannerMode(Banner.Mode.OFF)
                .run(args);
    }

    @Override
    public void run(ApplicationArguments args) throws Exception {
        ServerSocket serverSocket = null;
        InputStream inputStream = null;
        ObjectInputStream objectInputStream = null;
        Long startime = System.currentTimeMillis();
        try {
            serverSocket = new ServerSocket(2020);
            while (true) {
                Socket client = serverSocket.accept();
                inputStream = client.getInputStream();
                objectInputStream = new ObjectInputStream(new BufferedInputStream(inputStream));
                Object object = objectInputStream.readObject();
                DataPackage dataPackage = (DataPackage) object;
                int number = dataPackage.getNumber();
                List<Integer> sequence = dataPackage.getSequence();
                Picture picture = dataPackage.getPicture();
                String loc = dataPackage.getLoc();
                double eta = dataPackage.getEta();

                Long Currentime = dataPackage.getCurrentime();
                Long fun1time = dataPackage.getFun1time();
                List<Double> compCapacity = dataPackage.getCompCapacity();
                System.out.println("=====================");

                String methodName = "func" + number;
                Method method = serverService.getClass().getMethod(methodName, Class.forName("java.util.List"), Picture.class, Class.forName("java.lang.String"), Class.forName("java.lang.Double"),
                        Class.forName("java.lang.Long"),Class.forName("java.lang.Long"), Class.forName("java.lang.Long"), Class.forName("java.util.List"));
                method.invoke(serverService, sequence, picture, loc, eta, Currentime, startime, fun1time, compCapacity);
            }
        } catch (IOException | ClassNotFoundException e) {
            e.printStackTrace();
        } finally {
            try {
                if (objectInputStream != null) {
                    objectInputStream.close();
                }
                if (inputStream != null) {
                    inputStream.close();
                }
                if (serverSocket != null) {
                    serverSocket.close();
                }
            } catch (IOException e) {
                e.printStackTrace();
            }
        }
    }
}
