package com.pitong.business.service;

import com.pitong.business.item.DataPackage;
import com.pitong.business.item.Picture;
import com.sun.scenario.effect.impl.sw.sse.SSEBlend_SRC_OUTPeer;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.beans.factory.annotation.Value;
import org.springframework.stereotype.Service;

import java.io.*;
import java.net.Socket;
import java.util.LinkedList;
import java.util.List;

@Service
@parameters
public class ServerService {

    @Autowired
    private IPService ipService;
    private List<String> list = new LinkedList<>();

    private static final String in_file = "/pic/in.jpg";
    private static final String out_file = "/pic/out.jpg";
    private static final String in_file1 = "/pic/in1.jpg";
    private static final String in_file2 = "/pic/in2.jpg";
    private static final String out_file1 = "/pic/out1.jpg";
    private static final String out_file2 = "/pic/out2.jpg";

    @Value("${coe}")
    private double coe;

    @Value("${slot}")
    private Long slot;  //时隙值

    @Value("${cldurl}")
    private String cldurl;  //云地址

    @Value("${cldport}")
    private int cldport;   //云端口

//    private void analysisAnno() {
//        Class<ServerService> serverServiceClass = ServerService.class;
//        parameters parametrs = serverServiceClass.getAnnotation(parameters.class);
//        double coe1 = parametrs.coe();
//        coe = coe1;
//        long slot1 = parametrs.slot();
//        slot = slot1;
//        String cldUrl = parametrs.cldUrl();
//        cldurl = cldUrl;
//        int cldPort = parametrs.cldPort();
//        cldport = cldPort;
//    }

    public void func1(List<Integer> sequence, Picture picture, String loc, Double eta,
                      Long Currentime, Long startime, Long fun1time, List<Double> compCapacity) {

        saveToFile(picture, in_file);
        fun1time = System.currentTimeMillis();
        communicationToCloud("==========================");
        System.out.println("=========1==========");
        communicationToCloud("receive from sate"+sequence.get(0));
        System.out.println("=========2==========");
        cutProcess(eta);
        Long l11 = System.currentTimeMillis();

        double compCap = compCapacity.get(sequence.get(0)-1);
        long length = picture.getData().length/1024;
        System.out.println(length);
        communicationToCloud("picture size"+length);
        System.out.println("=========3==========");
        Long latency = Math.round(length/compCap);
//        System.out.println(latency-(l11-fun1time));
        try {
            if(latency > (l11-fun1time)){
                Thread.sleep(latency-Math.round(l11-fun1time));
//                System.out.println("true");
            }
        } catch (InterruptedException e) {
            e.printStackTrace();
        }
        long l1 = System.currentTimeMillis();
        communicationToCloud("task 1 spend time: "+(l1-fun1time)+"ms");
        communicationToCloud("--------------------------");
        System.out.println("=========4==========");
        System.out.println("task 1 spend time: "+(l1-fun1time)+"ms");
        System.out.println("---------------------");
        DataPackage dataPackage1 = combine(2, sequence, loc, out_file1, l1, fun1time, compCapacity);
        DataPackage dataPackage2 = combine(3, sequence, loc, out_file2, l1, fun1time, compCapacity);
        String app_name2 = "sate" + sequence.get(1);
        String IP2 = ipService.getIpByAppName(app_name2);
        String app_name3 = "sate" + sequence.get(2);
        String IP3 = ipService.getIpByAppName(app_name3);

        startime += 20*1000;
        communicationToCloud("current slot: " + ((System.currentTimeMillis()-startime)/slot + 1));
        System.out.println("current slot: " + ((System.currentTimeMillis()-startime)/slot + 1));
        send(dataPackage1, IP2, 2020, startime);
        communicationToCloud("transmission success!");
        System.out.println("transmission success!");
        communicationToCloud("==========================");
        System.out.println("=====================");
        System.out.println("current slot: " + ((System.currentTimeMillis()-startime)/slot + 1));
        send(dataPackage2, IP3, 2020, startime);
        communicationToCloud("transmission success!");
        System.out.println("transmission success!");
        communicationToCloud("==========================");
        System.out.println("=====================");
        sendToCloud(list);
    }



    public void func2(List<Integer> sequence, Picture picture, String loc, Double eta, Long Currentime,
                      Long startime, Long fun1time, List<Double> compCapacity) {


        long l2 = System.currentTimeMillis();

        communicationToCloud("==========================");
        communicationToCloud("receive from sate"+sequence.get(1));

        saveToFile(picture, in_file);
        double compCap = compCapacity.get(sequence.get(1)-1);
        long length = picture.getData().length/1024;

        greyProcess();

        long l20 = System.currentTimeMillis();
        Long latency = Math.round(length/compCap);
//        System.out.println(latency-(l20-l2));
        try {
            if(latency > (l20-l2)){
                Thread.sleep(latency-(l20-l2));
//                System.out.println("true");
            }
        } catch (InterruptedException e) {
            e.printStackTrace();
        }
        long l21 = System.currentTimeMillis();
//        System.out.println("exec end timestamp: " + l21);
        System.out.println("task 2 Spend time: "+(l21-l2)+"ms");
        communicationToCloud("task 2 Spend time: "+(l21-l2)+"ms");
        System.out.println("---------------------");
        communicationToCloud("--------------------------");
        DataPackage dataPackage = combine(4, sequence, loc, out_file, l21, fun1time, compCapacity);
        String app_name4 = "sate" + sequence.get(3);
        String IP4 = ipService.getIpByAppName(app_name4);
        communicationToCloud("current slot: " + ((System.currentTimeMillis()-startime)/slot + 1));
        System.out.println("current slot: " + ((System.currentTimeMillis()-startime)/slot + 1));
        send(dataPackage, IP4, 2020, startime);
        System.out.println("transmission success!");
        communicationToCloud("transmission success!");
        communicationToCloud("==========================");
        sendToCloud(list);
        System.out.println("=====================");
    }

    public void func3(List<Integer> sequence, Picture picture, String loc, Double eta,
                      Long Currentime, Long startime, Long fun1time, List<Double> compCapacity) {


        long l2 = System.currentTimeMillis();

        saveToFile(picture, in_file);
        communicationToCloud("==========================");
        communicationToCloud("receive from sate"+sequence.get(2));

        double compCap = compCapacity.get(sequence.get(2)-1);
        long length = picture.getData().length/1024;;
        greyProcess();
        long l20 = System.currentTimeMillis();
        Long latency = Math.round(length/compCap);
//        System.out.println(latency-(l20-l2));
        try {
            if(latency > (l20-l2)){
                Thread.sleep(latency-(l20-l2));
//                System.out.println("true");
            }
        } catch (InterruptedException e) {
            e.printStackTrace();
        }
        long l22 = System.currentTimeMillis();
//        System.out.println("exec end timestamp: " + l22);
        communicationToCloud("task 3 Spend time: "+(l22-l2)+"ms");
        communicationToCloud("--------------------------");
        System.out.println("task 3 Spend time: "+(l22-l2)+"ms");
        System.out.println("---------------------");
        DataPackage dataPackage = combine(5, sequence, loc, out_file, l22, fun1time, compCapacity);
        String app_name5 = "sate" + sequence.get(4);
        String IP5 = ipService.getIpByAppName(app_name5);
        communicationToCloud("current slot: " + ((System.currentTimeMillis()-startime)/slot + 1));
        System.out.println("current slot: " + ((System.currentTimeMillis()-startime)/slot + 1));
        send(dataPackage, IP5, 2020, startime);
        communicationToCloud("transmission success!");
        communicationToCloud("==========================");
        sendToCloud(list);
        System.out.println("transmission success!");
        System.out.println("=====================");
    }

    public void func4(List<Integer> sequence, Picture picture, String loc, Double eta,
                      Long Currentime, Long startime, Long fun1time, List<Double> compCapacity) {


        long l2 = System.currentTimeMillis();
        try {
            Thread.sleep(10);
        } catch (InterruptedException e) {
            e.printStackTrace();
        }
        saveToFile(picture, in_file);
        communicationToCloud("==========================");
        communicationToCloud("receive from sate"+sequence.get(3));
        double compCap = compCapacity.get(sequence.get(3)-1);
        long length = picture.getData().length/1024;

        binaryProcess();
        long l20 = System.currentTimeMillis();
        Long latency = Math.round(length/compCap);
//        System.out.println(latency-(l20-l2));
        try {
            if(latency > (l20-Currentime)){
                Thread.sleep(latency-(l20-l2));
//                System.out.println("true");
            }
        } catch (InterruptedException e) {
            e.printStackTrace();
        }

        long l22 = System.currentTimeMillis();
//        System.out.println("exec end timestamp: " + l22);
        System.out.println("task 4 Spend time: "+(l22-l2)+"ms");
        System.out.println("---------------------");
        communicationToCloud("task 4 Spend time: "+(l22-l2)+"ms");
        communicationToCloud("--------------------------");
        DataPackage dataPackage = combine(6, sequence, "top", out_file, l22, fun1time, compCapacity);
        String app_name6 = "sate" + sequence.get(5);
        String IP6 = ipService.getIpByAppName(app_name6);
        communicationToCloud("current slot: " + ((System.currentTimeMillis()-startime)/slot + 1));
        System.out.println("current slot: " + ((System.currentTimeMillis()-startime)/slot + 1));
        send(dataPackage, IP6, 2020, startime);
        communicationToCloud("transmission success!");
        communicationToCloud("==========================");
        sendToCloud(list);
        System.out.println("transmission success!");
        System.out.println("=====================");
    }

    public void func5(List<Integer> sequence, Picture picture, String loc, Double eta,
                      Long Currentime, Long startime, Long fun1time, List<Double> compCapacity) {


        long l2 = System.currentTimeMillis();

        saveToFile(picture, in_file);
        communicationToCloud("==========================");
        communicationToCloud("receive from sate"+sequence.get(4));
        double compCap = compCapacity.get(sequence.get(4)-1);
        long length = picture.getData().length/1024;

        binaryProcess();
        long l20 = System.currentTimeMillis();

        Long latency = Math.round(length/compCap);
//        System.out.println(latency-(l20-l2));
        try {
            if(latency > (l20-l2)){
                Thread.sleep(latency-(l20-l2));
//                System.out.println("true");
            }
        } catch (InterruptedException e) {
            e.printStackTrace();
        }
        long l22 = System.currentTimeMillis();
//        System.out.println("exec end timestamp: " + l22);
        communicationToCloud("task 5 Spend time: "+(l22-l2)+"ms");
        communicationToCloud("--------------------------");
        System.out.println("task 5 Spend time: "+(l22-l2)+"ms");
        System.out.println("---------------------");
        DataPackage dataPackage = combine(6, sequence, "bottom", out_file, l22, fun1time, compCapacity);
        String app_name6 = "sate" + sequence.get(5);
        String IP6 = ipService.getIpByAppName(app_name6);
        communicationToCloud("current slot: " + ((System.currentTimeMillis()-startime)/slot + 1));
        System.out.println("current slot: " + ((System.currentTimeMillis()-startime)/slot + 1));
        send(dataPackage, IP6, 2020, startime);
        communicationToCloud("transmission success!");
        communicationToCloud("==========================");
        sendToCloud(list);
        System.out.println("transmission success!");
        System.out.println("=====================");
    }

    static Long Currentime1 = 0L;
    public void func6(List<Integer> sequence, Picture picture, String loc, Double eta,
                      Long Currentime, Long startime, Long fun1time, List<Double> compCapacity) {


        long l2 = System.currentTimeMillis();

//        System.out.println("picture size: "+ length +"K");
        if (loc.equals("top")) {
            saveToFile(picture, in_file1);
        } else {
            saveToFile(picture, in_file2);
        }
        File file1 = new File(in_file1);
        File file2 = new File(in_file2);

        if (file1.exists() && file2.exists()) {
            communicationToCloud("==========================");
            communicationToCloud("receive from sate"+sequence.get(5));

            mergePorcess();

            double compCap = compCapacity.get(sequence.get(5)-1);
            long length = picture.getData().length/1024;
            Long latency = Math.round(length/compCap);
            long l20 = System.currentTimeMillis();
//            System.out.println(latency-(l20-Currentime1));
            try {
                if(latency > l20-Currentime1){
                    Thread.sleep(latency-(l20-Currentime1));
//                    System.out.println("ture");
                }
            } catch (InterruptedException e) {
                e.printStackTrace();
            }
            long l22 = System.currentTimeMillis();
//            System.out.println("exec end timestamp: " + l22);
            communicationToCloud("task 6 Spend time: " + (l22 - Currentime1) + "ms");
            communicationToCloud("--------------------------");
            System.out.println("task 6 Spend time: " + (l22 - Currentime1) + "ms");
            System.out.println("---------------------");
            DataPackage dataPackage = combine(7, sequence, null, out_file, l22, fun1time, compCapacity);
            String app_name7 = "sate" + sequence.get(6);
            String IP7 = ipService.getIpByAppName(app_name7);

            startime += 20*1000;
            System.out.println("current slot: " + ((System.currentTimeMillis()-startime)/slot + 1));
            communicationToCloud("current slot: " + ((System.currentTimeMillis()-startime)/slot + 1));
            send(dataPackage, IP7, 2020, startime);
            communicationToCloud("transmission success!");
            communicationToCloud("==========================");
            sendToCloud(list);
            System.out.println("transmission success!");
            System.out.println("=====================");
            file1.delete();
            file2.delete();
            Currentime1 = 0L;
        }
        else if (file1.exists() || file2.exists()) {
            Currentime1 = l2;
        }
    }

    public void func7(List<Integer> sequence, Picture picture, String loc, Double eta,
                      Long Currentime, Long startime, Long fun1time, List<Double> compCapacity) {


        long l2 = System.currentTimeMillis();
/*        try {
            Thread.sleep(10);
        } catch (InterruptedException e) {
            e.printStackTrace();
        }*/
        saveToFile(picture, in_file);
        communicationToCloud("==========================");
        communicationToCloud("receive from sate"+sequence.get(6));
        double compCap = compCapacity.get(sequence.get(6)-1);
        long length = picture.getData().length/1024;

        tailorProcess(coe);

        long l20 = System.currentTimeMillis();
        Long latency = Math.round(length/compCap);
//        System.out.println(latency-(l20-l2));

        try {
            if(latency > l20-l2){
                Thread.sleep(latency-(l20-l2));
//                System.out.println("true");
            }
        } catch (InterruptedException e) {
            e.printStackTrace();
        }
        long l22 = System.currentTimeMillis();
        communicationToCloud("task 7 Spend time: "+(l22-l2)+"ms");
        communicationToCloud("--------------------------");
        System.out.println("task 7 Spend time: "+(l22-l2)+"ms");
        System.out.println("---------------------");

        System.out.println("task total time: "+(l22-fun1time)+"ms");
        communicationToCloud("task total time: "+(l22-fun1time)+"ms");
        communicationToCloud("==========================");
        sendToCloud(list);



/*
        System.out.println("task total time: "+(l22-fun1time)+"ms");
        System.out.println("=====================");*/
    }


    private void send(DataPackage dataPackage, String ip, int port, Long startime) {
        Socket socket = null;
        try {
            communicationToCloud("next hop address"+ip);
            System.out.println("next hop address"+ip);
            socket = new Socket(ip, port);
            ObjectOutputStream objectOutputStream = new ObjectOutputStream(socket.getOutputStream());
            objectOutputStream.writeObject(dataPackage);
        } catch (IOException e) {
            System.out.println("current slot unreachable!");
            communicationToCloud("current slot unreachable!");
            Long waitime = slot-(System.currentTimeMillis()-startime)%slot;
            try {
                Thread.sleep(waitime+10);
            } catch (InterruptedException ex) {
                ex.printStackTrace();
            }
            communicationToCloud (">>>>>>>> try again >>>>>>>>");
            communicationToCloud ("current slot: " + ((System.currentTimeMillis()-startime)/slot + 1));
//            communicationToCloud (" ...");
            System.out.println(">>>>>>>>>>>>>>>>>>>");
            System.out.println("blocked current slot: " + ((System.currentTimeMillis()-startime)/slot + 1));
            System.out.println("try again ...");
            send(dataPackage, ip, port, startime);
//            e.printStackTrace();
        } finally {
            try {
                if (socket != null) {
                    socket.close();
                }
            } catch (IOException e) {
                e.printStackTrace();
            }
        }
    }

    private void communicationToCloud(String s) {
        list.add(s);
    }

    private void sendToCloud(List<String> list) {
        Socket ss = null;
        try {
            //ip来自云地址
            ss = new Socket(cldurl, cldport);
            ObjectOutputStream objectOutputStream = new ObjectOutputStream(ss.getOutputStream());
            objectOutputStream.writeObject(list);
            list.clear();
        } catch (IOException e) {
            e.printStackTrace();
        }finally {
            try {
                if (ss != null) {
                    ss.close();
                }
            } catch (IOException e) {
                e.printStackTrace();
            }
        }
    }


    private DataPackage combine(int number, List<Integer> sequence, String loc, String file_path,
                                Long Currentime, Long fun1time, List<Double> compCapacity) {
        DataPackage dataPackage = new DataPackage();
        dataPackage.setNumber(number);
        dataPackage.setPicture(loadPicture(file_path));
        dataPackage.setSequence(sequence);
        dataPackage.setLoc(loc);
        dataPackage.setCurrentime(Currentime);
        dataPackage.setFun1time(fun1time);
        dataPackage.setCompCapacity(compCapacity);
        return dataPackage;
    }

    private void saveToFile(Picture picture, String file_path) {
        byte[] pic_data = picture.getData();
        File targetFile = new File(file_path);
        if (targetFile.exists()) {
            targetFile.delete();
        }
        //为什么创建父类
        createParents(targetFile);
        try {
            targetFile.createNewFile();
            FileOutputStream fileOutputStream = new FileOutputStream(targetFile);
            fileOutputStream.write(pic_data);
        } catch (IOException e) {
            e.printStackTrace();
        }
    }

    private void tailorProcess(double coe) {
        try {
            String command = "python tailor-pro.py " + in_file + " " + out_file + " " + coe;
            Process process = Runtime.getRuntime().exec(command);
            process.waitFor();
        } catch (IOException | InterruptedException e) {
            e.printStackTrace();
        }
    }


    private void mergePorcess() {
        try {
            String command = "python merge-pro.py " + in_file1 + " " + in_file2 + " " + out_file;
            Process process = Runtime.getRuntime().exec(command);
            process.waitFor();
        } catch (IOException | InterruptedException e) {
            e.printStackTrace();
        }
    }

    private void binaryProcess() {
        try {
            String command = "python binary-pro.py " + in_file + " " + out_file;
            Process process = Runtime.getRuntime().exec(command);
            process.waitFor();
        } catch (IOException | InterruptedException e) {
            e.printStackTrace();
        }
    }

    private void greyProcess() {
        try {
            String command = "python grey-pro.py " + in_file + " " + out_file;
            Process process = Runtime.getRuntime().exec(command);
            process.waitFor();
        } catch (IOException | InterruptedException e) {
            e.printStackTrace();
        }
    }

    private void cutProcess(double eta) {
        try {
            String command = "python cut-pro.py " + in_file + " " + out_file1 + " " + out_file2 + " " + eta;
            Process process = Runtime.getRuntime().exec(command);
            process.waitFor();
        } catch (IOException | InterruptedException e) {
            e.printStackTrace();
        }
    }

    private void createParents(File f) {
        String parentName = f.getParent();
        File parent = new File(parentName);
        if (!parent.exists()) {
            createParents(parent);
            parent.mkdir();
        }
    }

    private Picture loadPicture(String pic_url) {
        try {
            File f = new File(pic_url);
            InputStream is = new FileInputStream(f);
            byte[] b = new byte[(int) f.length()];
            is.read(b);
            is.close();
            Picture picture = new Picture();
            picture.setData(b);
            return picture;
        } catch (Exception e) {
            e.printStackTrace();
        }
        return null;
    }
}
